package com.aidex.common.gps.server.impl;

import com.aidex.common.constant.Constants;
import com.aidex.common.core.redis.RedisCache;
import com.aidex.common.gps.common.GeneratorGspApi;
import com.aidex.common.gps.common.GpsApi;
import com.aidex.common.gps.common.GpsRequest;
import com.aidex.common.gps.domain.DeviceEntity;
import com.aidex.common.gps.domain.LocationEntity;
import com.aidex.common.gps.server.IGpsService;
import com.aidex.system.domain.SysShip;
import com.aidex.system.service.SysShipService;
import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
public class GpsService implements IGpsService {

    @Autowired
    private GeneratorGspApi generatorGspApi;
    @Autowired
    private GpsRequest gpsRequest;
    @Autowired
    private SysShipService sysShipService;
    @Autowired
    private RedisCache redisCache;


    public String getLocationUrl(String shipId){
        SysShip sysShip = sysShipService.get(shipId);
        return "";
//        return generatorGspApi.GenerationMapUrl(GeneratorGspApi.RquestMethod.follow,sysShip.getShipNum(), GeneratorGspApi.GpsMapType.QQ);
    }

    public String getPlayUrl(String shipId){
        SysShip sysShip = sysShipService.get(shipId);
        String userInfo = redisCache.getStringValue(Constants.GPS_LOGIN_INFO_PREFIX);
        Map<String, Object> params = generatorGspApi.GeneratorQueryParams(GpsApi.findDeviceInfo);
        params.put("macid",sysShip.getShipNum());
        DeviceEntity deviceEntity = gpsRequest.post(params).toJavaObject(DeviceEntity.class);
        return generatorGspApi.GenerationMapUrl(GeneratorGspApi.GpsMapType.QQ,sysShip.getShipNanme(),deviceEntity.getObjectid(), JSONObject.parse(userInfo).getString("id"));
    }

    public LocationEntity getLocation(String shipId){
        SysShip sysShip = sysShipService.get(shipId);
        Map<String, Object> params = generatorGspApi.GeneratorQueryParams(GpsApi.findLocation);
        params.put("macid",sysShip.getShipNum());
        params.put("mapType", GeneratorGspApi.GpsMapType.QQ);
        LocationEntity locationEntitie = gpsRequest.post(params).toJavaObject(LocationEntity.class);
        return locationEntitie;
    }

    public List<LocationEntity> getLocationBatch(){
        List<SysShip> sysShips = sysShipService.findList(new SysShip());
        String macIds = sysShips.stream().map(SysShip::getShipNum).collect(Collectors.joining(","));
        Map<String, Object> params = generatorGspApi.GeneratorQueryParams(GpsApi.findLocationByBatch);
        params.put("macids",macIds);
        params.put("mapType", GeneratorGspApi.GpsMapType.QQ);
        List<LocationEntity> locationEntities = gpsRequest.postArray(params).toJavaList(LocationEntity.class);
         return locationEntities;
    }
}
